﻿var express = require('express');
var router = express.Router();
var routeConfig = [];
var moduleHandlerFactory = require('./ModuleHandlerFactory');
Array.prototype.any = function (callBack) {
    var len = this.length;
    if (len > 0) {
        for (i = 0; i < len; ++i) {
            if (callBack(this[i], i, this)) {
                return true;
            }
        }
    }
    return false;
};
var self=this;
this.mapRoute = function (route) {
    //console.log("mapRoute");
    if (!routeConfig.any(function (item, index, array) {
        return item.name.toLowerCase() == route.toLowerCase();
    })) {
       //console.log("all:" + router.all);
        routeConfig.push(route);
        router.all(route.url, function (req, res) {

             moduleHandlerFactory.getHandler(req, function (error,data) {
                 var len = data.length;
              
                 for (i = 0; i < len; ++i) {
                   
                     var handled = data[i].handle({ request: req, response: res ,route:route});
                     if (handled) {
                         break;
                     }
                }
             });

            //此处处理管道过程
            //load
            //authorized
            //unload       
        });
        
       
    }
    
};

this.router = router || {} ;

exports.router = router;