﻿var controllerBuilderFactory = require("./ControllerBuilderFactory");
this.handle = function (context) {
    //if (context.request.url.indexOf("sso/login") > -1) {
    //    context.response.cookie("ticket", "abcdedfisdjfassdk");
    //    context.response.render("login", { title: "单点登陆" });
    //    return true;
    //}
    console.log("defaultHandler:onStart");
    var controllerBuilder = controllerBuilderFactory.getControllerBuilder();
    var controllerInstance = controllerBuilder.createController(context);
    var action = controllerInstance.controllerContext.action;
    console.log("defaultHandler:action="+action);
    if (controllerInstance == null || controllerInstance == undefined
        || controllerInstance[action] == undefined || controllerInstance[controllerInstance.controllerContext.action] == null) {
        context.response.send(404, 'Sorry, we cannot find that!');
        return;
    }
    var valueProvider = getValueProvider(context);
    var actionResult = controllerInstance[action](valueProvider.values());

    actionResult.execute(context);
    return true;
    //context.response.render(actionResult.view, actionResult.data);
   // context.response.write("i 'm in default Haendler");
   // console.log("when the response redirect then will this be handler");
}

var tryGetValue = function (context, name) {
    var valueProvider = getValueProvider(context);
    var attempedValue =valueProvider.tryGetValue(name);
    if (attempedValue == undefined || attempedValue == null || attempedValue=="") {
        attempedValue = context.route.defaults[attempedValue];
    }
    return attempedValue;
}

var getValueProvider = function (context) {
    var dic = {};
    //queryString
    var param = context.request.query;
    var len = param.length;
    for (var item in param) {
        var key = item;
       
            dic[key] = param[item];
       
      

    };
    //post data
    var post = context.request.body;
    for (var item in post) {
        var key = item;
        dic[key] = post[item];

    };

    var routeInfo = context.request.route.params;
     for (var item in routeInfo) {
        var key = item;
       
        dic[key] = routeInfo[item];



    };

    return {
        tryGetValue: function (name) {
            return dic[name];
        },
        values: function () {
            return dic;
        }
    }
}